/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_AMQP_ServerProxy__
#define qpid_framing_AMQP_ServerProxy__

#include <AMQP_ServerOperations.h>
#include <FieldTable.h>
#include <OutputHandler.h>

namespace qpid {
namespace framing {

class AMQP_ServerProxy : public AMQP_ServerOperations
{
private:
    ProtocolVersion version;
    OutputHandler* out;
    AMQP_ServerOperations::AccessHandler* AccessHandlerPtr;
    AMQP_ServerOperations::BasicHandler* BasicHandlerPtr;
    AMQP_ServerOperations::ChannelHandler* ChannelHandlerPtr;
    AMQP_ServerOperations::ConnectionHandler* ConnectionHandlerPtr;
    AMQP_ServerOperations::DtxHandler* DtxHandlerPtr;
    AMQP_ServerOperations::ExchangeHandler* ExchangeHandlerPtr;
    AMQP_ServerOperations::FileHandler* FileHandlerPtr;
    AMQP_ServerOperations::QueueHandler* QueueHandlerPtr;
    AMQP_ServerOperations::StreamHandler* StreamHandlerPtr;
    AMQP_ServerOperations::TestHandler* TestHandlerPtr;
    AMQP_ServerOperations::TunnelHandler* TunnelHandlerPtr;
    AMQP_ServerOperations::TxHandler* TxHandlerPtr;

public:
    AMQP_ServerProxy(OutputHandler* out, u_int8_t major, u_int8_t minor);
    ProtocolVersion& getProtocolVersion() {return version;}
    virtual ~AMQP_ServerProxy() {}

	// Get methods for handlers

    virtual inline AMQP_ServerOperations::AccessHandler* getAccessHandler() { return &access;}
    virtual inline AMQP_ServerOperations::BasicHandler* getBasicHandler() { return &basic;}
    virtual inline AMQP_ServerOperations::ChannelHandler* getChannelHandler() { return &channel;}
    virtual inline AMQP_ServerOperations::ConnectionHandler* getConnectionHandler() { return &connection;}
    virtual inline AMQP_ServerOperations::DtxHandler* getDtxHandler() { return &dtx;}
    virtual inline AMQP_ServerOperations::ExchangeHandler* getExchangeHandler() { return &exchange;}
    virtual inline AMQP_ServerOperations::FileHandler* getFileHandler() { return &file;}
    virtual inline AMQP_ServerOperations::QueueHandler* getQueueHandler() { return &queue;}
    virtual inline AMQP_ServerOperations::StreamHandler* getStreamHandler() { return &stream;}
    virtual inline AMQP_ServerOperations::TestHandler* getTestHandler() { return &test;}
    virtual inline AMQP_ServerOperations::TunnelHandler* getTunnelHandler() { return &tunnel;}
    virtual inline AMQP_ServerOperations::TxHandler* getTxHandler() { return &tx;}

	// Inner class definitions

    // ==================== class Access ====================
    class Access : virtual public AMQP_ServerOperations::AccessHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Access(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Access() {}

        // Protocol methods

        virtual void request( u_int16_t channel,
                            const string& realm,
                            bool exclusive,
                            bool passive,
                            bool active,
                            bool write,
                            bool read );
    }; // class Access

    // ==================== class Basic ====================
    class Basic : virtual public AMQP_ServerOperations::BasicHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Basic(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Basic() {}

        // Protocol methods

        virtual void ack( u_int16_t channel,
                            u_int64_t deliveryTag,
                            bool multiple );

        virtual void cancel( u_int16_t channel,
                            const string& consumerTag,
                            bool nowait );

        virtual void consume( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            const string& consumerTag,
                            bool noLocal,
                            bool noAck,
                            bool exclusive,
                            bool nowait,
                            const FieldTable& arguments );

        virtual void get( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            bool noAck );

        virtual void publish( u_int16_t channel,
                            u_int16_t ticket,
                            const string& exchange,
                            const string& routingKey,
                            bool mandatory,
                            bool immediate );

        virtual void qos( u_int16_t channel,
                            u_int32_t prefetchSize,
                            u_int16_t prefetchCount,
                            bool global );

        virtual void recover( u_int16_t channel,
                            bool requeue );

        virtual void reject( u_int16_t channel,
                            u_int64_t deliveryTag,
                            bool requeue );
    }; // class Basic

    // ==================== class Channel ====================
    class Channel : virtual public AMQP_ServerOperations::ChannelHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Channel(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Channel() {}

        // Protocol methods

        virtual void close( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk( u_int16_t channel );

        virtual void flow( u_int16_t channel,
                            bool active );

        virtual void flowOk( u_int16_t channel,
                            bool active );

        virtual void open( u_int16_t channel,
                            const string& outOfBand );
    }; // class Channel

    // ==================== class Connection ====================
    class Connection : virtual public AMQP_ServerOperations::ConnectionHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Connection(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Connection() {}

        // Protocol methods

        virtual void close( u_int16_t channel,
                            u_int16_t replyCode,
                            const string& replyText,
                            u_int16_t classId,
                            u_int16_t methodId );

        virtual void closeOk( u_int16_t channel );

        virtual void open( u_int16_t channel,
                            const string& virtualHost,
                            const string& capabilities,
                            bool insist );

        virtual void secureOk( u_int16_t channel,
                            const string& response );

        virtual void startOk( u_int16_t channel,
                            const FieldTable& clientProperties,
                            const string& mechanism,
                            const string& response,
                            const string& locale );

        virtual void tuneOk( u_int16_t channel,
                            u_int16_t channelMax,
                            u_int32_t frameMax,
                            u_int16_t heartbeat );
    }; // class Connection

    // ==================== class Dtx ====================
    class Dtx : virtual public AMQP_ServerOperations::DtxHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Dtx(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Dtx() {}

        // Protocol methods

        virtual void select( u_int16_t channel );

        virtual void start( u_int16_t channel,
                            const string& dtxIdentifier );
    }; // class Dtx

    // ==================== class Exchange ====================
    class Exchange : virtual public AMQP_ServerOperations::ExchangeHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Exchange(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Exchange() {}

        // Protocol methods

        virtual void declare( u_int16_t channel,
                            u_int16_t ticket,
                            const string& exchange,
                            const string& type,
                            bool passive,
                            bool durable,
                            bool autoDelete,
                            bool internal,
                            bool nowait,
                            const FieldTable& arguments );

        virtual void delete_( u_int16_t channel,
                            u_int16_t ticket,
                            const string& exchange,
                            bool ifUnused,
                            bool nowait );
    }; // class Exchange

    // ==================== class File ====================
    class File : virtual public AMQP_ServerOperations::FileHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        File(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~File() {}

        // Protocol methods

        virtual void ack( u_int16_t channel,
                            u_int64_t deliveryTag,
                            bool multiple );

        virtual void cancel( u_int16_t channel,
                            const string& consumerTag,
                            bool nowait );

        virtual void consume( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            const string& consumerTag,
                            bool noLocal,
                            bool noAck,
                            bool exclusive,
                            bool nowait );

        virtual void open( u_int16_t channel,
                            const string& identifier,
                            u_int64_t contentSize );

        virtual void openOk( u_int16_t channel,
                            u_int64_t stagedSize );

        virtual void publish( u_int16_t channel,
                            u_int16_t ticket,
                            const string& exchange,
                            const string& routingKey,
                            bool mandatory,
                            bool immediate,
                            const string& identifier );

        virtual void qos( u_int16_t channel,
                            u_int32_t prefetchSize,
                            u_int16_t prefetchCount,
                            bool global );

        virtual void reject( u_int16_t channel,
                            u_int64_t deliveryTag,
                            bool requeue );

        virtual void stage( u_int16_t channel );
    }; // class File

    // ==================== class Queue ====================
    class Queue : virtual public AMQP_ServerOperations::QueueHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Queue(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Queue() {}

        // Protocol methods

        virtual void bind( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            const string& exchange,
                            const string& routingKey,
                            bool nowait,
                            const FieldTable& arguments );

        virtual void declare( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            bool passive,
                            bool durable,
                            bool exclusive,
                            bool autoDelete,
                            bool nowait,
                            const FieldTable& arguments );

        virtual void delete_( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            bool ifUnused,
                            bool ifEmpty,
                            bool nowait );

        virtual void purge( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            bool nowait );
    }; // class Queue

    // ==================== class Stream ====================
    class Stream : virtual public AMQP_ServerOperations::StreamHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Stream(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Stream() {}

        // Protocol methods

        virtual void cancel( u_int16_t channel,
                            const string& consumerTag,
                            bool nowait );

        virtual void consume( u_int16_t channel,
                            u_int16_t ticket,
                            const string& queue,
                            const string& consumerTag,
                            bool noLocal,
                            bool exclusive,
                            bool nowait );

        virtual void publish( u_int16_t channel,
                            u_int16_t ticket,
                            const string& exchange,
                            const string& routingKey,
                            bool mandatory,
                            bool immediate );

        virtual void qos( u_int16_t channel,
                            u_int32_t prefetchSize,
                            u_int16_t prefetchCount,
                            u_int32_t consumeRate,
                            bool global );
    }; // class Stream

    // ==================== class Test ====================
    class Test : virtual public AMQP_ServerOperations::TestHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Test(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Test() {}

        // Protocol methods

        virtual void content( u_int16_t channel );

        virtual void contentOk( u_int16_t channel,
                            u_int32_t contentChecksum );

        virtual void integer( u_int16_t channel,
                            u_int8_t integer1,
                            u_int16_t integer2,
                            u_int32_t integer3,
                            u_int64_t integer4,
                            u_int8_t operation );

        virtual void integerOk( u_int16_t channel,
                            u_int64_t result );

        virtual void string_( u_int16_t channel,
                            const string& string1,
                            const string& string2,
                            u_int8_t operation );

        virtual void stringOk( u_int16_t channel,
                            const string& result );

        virtual void table( u_int16_t channel,
                            const FieldTable& table,
                            u_int8_t integerOp,
                            u_int8_t stringOp );

        virtual void tableOk( u_int16_t channel,
                            u_int64_t integerResult,
                            const string& stringResult );
    }; // class Test

    // ==================== class Tunnel ====================
    class Tunnel : virtual public AMQP_ServerOperations::TunnelHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Tunnel(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Tunnel() {}

        // Protocol methods

        virtual void request( u_int16_t channel,
                            const FieldTable& metaData );
    }; // class Tunnel

    // ==================== class Tx ====================
    class Tx : virtual public AMQP_ServerOperations::TxHandler
    {
    private:
        OutputHandler* out;
        AMQP_ServerProxy* parent;

    public:
        // Constructors and destructors

        Tx(OutputHandler* out, AMQP_ServerProxy* _parent) : 
            out(out) {parent = _parent;}
        virtual ~Tx() {}

        // Protocol methods

        virtual void commit( u_int16_t channel );

        virtual void rollback( u_int16_t channel );

        virtual void select( u_int16_t channel );
    }; // class Tx

private:
	// Inner class instances
	
    Access access;
    Basic basic;
    Channel channel;
    Connection connection;
    Dtx dtx;
    Exchange exchange;
    File file;
    Queue queue;
    Stream stream;
    Test test;
    Tunnel tunnel;
    Tx tx;

public:
	// Inner class instance get methods
	
    Access& getAccess();
    Basic& getBasic();
    Channel& getChannel();
    Connection& getConnection();
    Dtx& getDtx();
    Exchange& getExchange();
    File& getFile();
    Queue& getQueue();
    Stream& getStream();
    Test& getTest();
    Tunnel& getTunnel();
    Tx& getTx();

}; /* class AMQP_ServerProxy */

} /* namespace framing */
} /* namespace qpid */

#endif
