/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ChannelAlertBody__
#define qpid_framing_ChannelAlertBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ChannelAlertBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t replyCode;
    string replyText;
    FieldTable details;
     

public:
    typedef boost::shared_ptr<ChannelAlertBody> shared_ptr;

	// Constructors and destructors

    ChannelAlertBody(ProtocolVersion& version,
        u_int16_t replyCode,
        const string& replyText,
        const FieldTable& details
        ) :
        AMQMethodBody(version),
        replyCode(replyCode),
        replyText(replyText),
        details(details)
    { }


    inline ChannelAlertBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ChannelAlertBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ChannelAlertBody() {}
    
    // Attribute get methods

    inline u_int16_t getReplyCode() { return replyCode; }
    inline const string& getReplyText() { return replyText; }
    inline const FieldTable& getDetails() { return details; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ChannelAlert: ";
        out << "replyCode=" << replyCode;
        out << "; replyText=" << replyText;
        out << "; details=" << details;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 20;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 30;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* replyCode: short */
        size += 1 + replyText.length(); /* replyText: shortstr */
        size += details.size(); /* details: table */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(replyCode); /* replyCode: short */
        buffer.putShortString(replyText); /* replyText: shortstr */
        buffer.putFieldTable(details); /* details: table */
    }

    inline void decodeContent(Buffer& buffer)
    {
        replyCode = buffer.getShort(); /* replyCode: short */
        buffer.getShortString(replyText); /* replyText: shortstr */
        buffer.getFieldTable(details); /* details: table */
    }       



}; // class ChannelAlertBody


} // namespace framing
} // namespace qpid

#endif

