/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ChannelCloseBody__
#define qpid_framing_ChannelCloseBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ChannelCloseBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t replyCode;
    string replyText;
    u_int16_t classId;
    u_int16_t methodId;
     

public:
    typedef boost::shared_ptr<ChannelCloseBody> shared_ptr;

	// Constructors and destructors

    ChannelCloseBody(ProtocolVersion& version,
        u_int16_t replyCode,
        const string& replyText,
        u_int16_t classId,
        u_int16_t methodId
        ) :
        AMQMethodBody(version),
        replyCode(replyCode),
        replyText(replyText),
        classId(classId),
        methodId(methodId)
    { }


    inline ChannelCloseBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ChannelCloseBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ChannelCloseBody() {}
    
    // Attribute get methods

    inline u_int16_t getReplyCode() { return replyCode; }
    inline const string& getReplyText() { return replyText; }
    inline u_int16_t getClassId() { return classId; }
    inline u_int16_t getMethodId() { return methodId; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ChannelClose: ";
        out << "replyCode=" << replyCode;
        out << "; replyText=" << replyText;
        out << "; classId=" << classId;
        out << "; methodId=" << methodId;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 20;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 40;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* replyCode: short */
        size += 1 + replyText.length(); /* replyText: shortstr */
        size += 2; /* classId: short */
        size += 2; /* methodId: short */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(replyCode); /* replyCode: short */
        buffer.putShortString(replyText); /* replyText: shortstr */
        buffer.putShort(classId); /* classId: short */
        buffer.putShort(methodId); /* methodId: short */
    }

    inline void decodeContent(Buffer& buffer)
    {
        replyCode = buffer.getShort(); /* replyCode: short */
        buffer.getShortString(replyText); /* replyText: shortstr */
        classId = buffer.getShort(); /* classId: short */
        methodId = buffer.getShort(); /* methodId: short */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getChannelHandler()->close(channel,
                    replyCode,
                    replyText,
                    classId,
                    methodId
                    );
    }


}; // class ChannelCloseBody


} // namespace framing
} // namespace qpid

#endif

