/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_ConnectionOpenBody__
#define qpid_framing_ConnectionOpenBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class ConnectionOpenBody : public AMQMethodBody
{
	// Method field declarations

    string virtualHost;
    string capabilities;
    bool insist;
     

public:
    typedef boost::shared_ptr<ConnectionOpenBody> shared_ptr;

	// Constructors and destructors

    ConnectionOpenBody(ProtocolVersion& version,
        const string& virtualHost,
        const string& capabilities,
        bool insist
        ) :
        AMQMethodBody(version),
        virtualHost(virtualHost),
        capabilities(capabilities),
        insist(insist)
    { }


    inline ConnectionOpenBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline ConnectionOpenBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~ConnectionOpenBody() {}
    
    // Attribute get methods

    inline const string& getVirtualHost() { return virtualHost; }
    inline const string& getCapabilities() { return capabilities; }
    inline bool getInsist() { return insist; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "ConnectionOpen: ";
        out << "virtualHost=" << virtualHost;
        out << "; capabilities=" << capabilities;
        out << "; insist=" << insist;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 10;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 40;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + virtualHost.length(); /* virtualHost: shortstr */
        size += 1 + capabilities.length(); /* capabilities: shortstr */
        size += 1; /* insist: bit */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(virtualHost); /* virtualHost: shortstr */
        buffer.putShortString(capabilities); /* capabilities: shortstr */
        u_int8_t flags_2[1] = {0};
        flags_2[0] |= insist << 0; /* insist: bit */
        buffer.putOctet(flags_2[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(virtualHost); /* virtualHost: shortstr */
        buffer.getShortString(capabilities); /* capabilities: shortstr */
        u_int8_t flags_2[1];
        flags_2[0] = buffer.getOctet();
        insist = (1 << 0) & flags_2[0]; /* insist: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getConnectionHandler()->open(channel,
                    virtualHost,
                    capabilities,
                    insist
                    );
    }


}; // class ConnectionOpenBody


} // namespace framing
} // namespace qpid

#endif

