/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_DtxStartBody__
#define qpid_framing_DtxStartBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class DtxStartBody : public AMQMethodBody
{
	// Method field declarations

    string dtxIdentifier;
     

public:
    typedef boost::shared_ptr<DtxStartBody> shared_ptr;

	// Constructors and destructors

    DtxStartBody(ProtocolVersion& version,
        const string& dtxIdentifier
        ) :
        AMQMethodBody(version),
        dtxIdentifier(dtxIdentifier)
    { }


    inline DtxStartBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline DtxStartBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~DtxStartBody() {}
    
    // Attribute get methods

    inline const string& getDtxIdentifier() { return dtxIdentifier; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "DtxStart: ";
        out << "dtxIdentifier=" << dtxIdentifier;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 100;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 20;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 1 + dtxIdentifier.length(); /* dtxIdentifier: shortstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShortString(dtxIdentifier); /* dtxIdentifier: shortstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getShortString(dtxIdentifier); /* dtxIdentifier: shortstr */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getDtxHandler()->start(channel,
                    dtxIdentifier
                    );
    }


}; // class DtxStartBody


} // namespace framing
} // namespace qpid

#endif

