/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_QueueBindBody__
#define qpid_framing_QueueBindBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class QueueBindBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t ticket;
    string queue;
    string exchange;
    string routingKey;
    bool nowait;
    FieldTable arguments;
     

public:
    typedef boost::shared_ptr<QueueBindBody> shared_ptr;

	// Constructors and destructors

    QueueBindBody(ProtocolVersion& version,
        u_int16_t ticket,
        const string& queue,
        const string& exchange,
        const string& routingKey,
        bool nowait,
        const FieldTable& arguments
        ) :
        AMQMethodBody(version),
        ticket(ticket),
        queue(queue),
        exchange(exchange),
        routingKey(routingKey),
        nowait(nowait),
        arguments(arguments)
    { }


    inline QueueBindBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline QueueBindBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~QueueBindBody() {}
    
    // Attribute get methods

    inline u_int16_t getTicket() { return ticket; }
    inline const string& getQueue() { return queue; }
    inline const string& getExchange() { return exchange; }
    inline const string& getRoutingKey() { return routingKey; }
    inline bool getNowait() { return nowait; }
    inline const FieldTable& getArguments() { return arguments; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "QueueBind: ";
        out << "ticket=" << ticket;
        out << "; queue=" << queue;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; nowait=" << nowait;
        out << "; arguments=" << arguments;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 50;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 20;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* ticket: short */
        size += 1 + queue.length(); /* queue: shortstr */
        size += 1 + exchange.length(); /* exchange: shortstr */
        size += 1 + routingKey.length(); /* routingKey: shortstr */
        size += 1; /* nowait: bit */
        size += arguments.size(); /* arguments: table */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(queue); /* queue: shortstr */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_5[1] = {0};
        flags_5[0] |= nowait << 0; /* nowait: bit */
        buffer.putOctet(flags_5[0]);
        buffer.putFieldTable(arguments); /* arguments: table */
    }

    inline void decodeContent(Buffer& buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(queue); /* queue: shortstr */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_5[1];
        flags_5[0] = buffer.getOctet();
        nowait = (1 << 0) & flags_5[0]; /* nowait: bit */
        buffer.getFieldTable(arguments); /* arguments: table */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getQueueHandler()->bind(channel,
                    ticket,
                    queue,
                    exchange,
                    routingKey,
                    nowait,
                    arguments
                    );
    }


}; // class QueueBindBody


} // namespace framing
} // namespace qpid

#endif

