/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_StreamPublishBody__
#define qpid_framing_StreamPublishBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class StreamPublishBody : public AMQMethodBody
{
	// Method field declarations

    u_int16_t ticket;
    string exchange;
    string routingKey;
    bool mandatory;
    bool immediate;
     

public:
    typedef boost::shared_ptr<StreamPublishBody> shared_ptr;

	// Constructors and destructors

    StreamPublishBody(ProtocolVersion& version,
        u_int16_t ticket,
        const string& exchange,
        const string& routingKey,
        bool mandatory,
        bool immediate
        ) :
        AMQMethodBody(version),
        ticket(ticket),
        exchange(exchange),
        routingKey(routingKey),
        mandatory(mandatory),
        immediate(immediate)
    { }


    inline StreamPublishBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline StreamPublishBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~StreamPublishBody() {}
    
    // Attribute get methods

    inline u_int16_t getTicket() { return ticket; }
    inline const string& getExchange() { return exchange; }
    inline const string& getRoutingKey() { return routingKey; }
    inline bool getMandatory() { return mandatory; }
    inline bool getImmediate() { return immediate; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "StreamPublish: ";
        out << "ticket=" << ticket;
        out << "; exchange=" << exchange;
        out << "; routingKey=" << routingKey;
        out << "; mandatory=" << mandatory;
        out << "; immediate=" << immediate;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 80;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 40;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 2; /* ticket: short */
        size += 1 + exchange.length(); /* exchange: shortstr */
        size += 1 + routingKey.length(); /* routingKey: shortstr */
        size += 1; /* Combinded bits: [mandatory, immediate] */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putShort(ticket); /* ticket: short */
        buffer.putShortString(exchange); /* exchange: shortstr */
        buffer.putShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_4[1] = {0};
        flags_4[0] |= mandatory << 0; /* mandatory: bit */
        flags_4[0] |= immediate << 1; /* immediate: bit */
        buffer.putOctet(flags_4[0]);
    }

    inline void decodeContent(Buffer& buffer)
    {
        ticket = buffer.getShort(); /* ticket: short */
        buffer.getShortString(exchange); /* exchange: shortstr */
        buffer.getShortString(routingKey); /* routingKey: shortstr */
        u_int8_t flags_4[1];
        flags_4[0] = buffer.getOctet();
        mandatory = (1 << 0) & flags_4[0]; /* mandatory: bit */
        immediate = (1 << 1) & flags_4[0]; /* immediate: bit */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getStreamHandler()->publish(channel,
                    ticket,
                    exchange,
                    routingKey,
                    mandatory,
                    immediate
                    );
    }


}; // class StreamPublishBody


} // namespace framing
} // namespace qpid

#endif

