/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_TestStringOkBody__
#define qpid_framing_TestStringOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class TestStringOkBody : public AMQMethodBody
{
	// Method field declarations

    string result;
     

public:
    typedef boost::shared_ptr<TestStringOkBody> shared_ptr;

	// Constructors and destructors

    TestStringOkBody(ProtocolVersion& version,
        const string& result
        ) :
        AMQMethodBody(version),
        result(result)
    { }


    inline TestStringOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline TestStringOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~TestStringOkBody() {}
    
    // Attribute get methods

    inline const string& getResult() { return result; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "TestStringOk: ";
        out << "result=" << result;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 120;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 21;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 4 + result.length(); /* result: longstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putLongString(result); /* result: longstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        buffer.getLongString(result); /* result: longstr */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getTestHandler()->stringOk(channel,
                    result
                    );
    }


}; // class TestStringOkBody


} // namespace framing
} // namespace qpid

#endif

