/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

/*
 * This file is auto-generated by Qpid Gentools v.0.1 - do not modify.
 * Supported AMQP versions:
 *   8-0
 */

#ifndef qpid_framing_TestTableOkBody__
#define qpid_framing_TestTableOkBody__

#include <string>
#include <sstream>

#include <amqp_types.h>
#include <AMQMethodBody.h>
#include <Buffer.h>
#include <FieldTable.h>

namespace qpid
{
namespace framing
{

 
class TestTableOkBody : public AMQMethodBody
{
	// Method field declarations

    u_int64_t integerResult;
    string stringResult;
     

public:
    typedef boost::shared_ptr<TestTableOkBody> shared_ptr;

	// Constructors and destructors

    TestTableOkBody(ProtocolVersion& version,
        u_int64_t integerResult,
        const string& stringResult
        ) :
        AMQMethodBody(version),
        integerResult(integerResult),
        stringResult(stringResult)
    { }


    inline TestTableOkBody(u_int8_t major, u_int8_t minor): AMQMethodBody(major, minor) {}
    inline TestTableOkBody(ProtocolVersion& version): AMQMethodBody(version) {}
    virtual ~TestTableOkBody() {}
    
    // Attribute get methods

    inline u_int64_t getIntegerResult() { return integerResult; }
    inline const string& getStringResult() { return stringResult; }

    // Helper methods
    
    inline void print(std::ostream& out) const
    {
	    out << "TestTableOk: ";
        out << "integerResult=" << integerResult;
        out << "; stringResult=" << stringResult;
    }

    inline u_int16_t amqpClassId() const
    {
    	return 120;
    }
    
    inline u_int16_t amqpMethodId() const
    {
    	return 31;
    }

    inline u_int32_t bodySize() const
    {
		u_int32_t size = 0;        
        size += 8; /* integerResult: longlong */
        size += 4 + stringResult.length(); /* stringResult: longstr */
        return size;
    }

    inline void encodeContent(Buffer& buffer) const
    {
        buffer.putLongLong(integerResult); /* integerResult: longlong */
        buffer.putLongString(stringResult); /* stringResult: longstr */
    }

    inline void decodeContent(Buffer& buffer)
    {
        integerResult = buffer.getLongLong(); /* integerResult: longlong */
        buffer.getLongString(stringResult); /* stringResult: longstr */
    }       

    inline void invoke(AMQP_ServerOperations& target, u_int16_t channel)
    {
        target.getTestHandler()->tableOk(channel,
                    integerResult,
                    stringResult
                    );
    }


}; // class TestTableOkBody


} // namespace framing
} // namespace qpid

#endif

